decision_forest_evaluator.h
/*
* Software License Agreement (BSD License)
*
* Point Cloud Library (PCL) - www.pointclouds.org
* Copyright (c) 2010-2011, Willow Garage, Inc.
*
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* * Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
* * Redistributions in binary form must reproduce the above
* copyright notice, this list of conditions and the following
* disclaimer in the documentation and/or other materials provided
* with the distribution.
* * Neither the name of Willow Garage, Inc. nor the names of its
* contributors may be used to endorse or promote products derived
* from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
* COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*
*/
#pragma once
#include <pcl/common/common.h>
#include <pcl/ml/dt/decision_forest.h>
#include <pcl/ml/dt/decision_tree_evaluator.h>
#include <pcl/ml/feature_handler.h>
#include <pcl/ml/stats_estimator.h>
#include <vector>
namespace pcl {
/** Utility class for evaluating a decision forests. */
template <class FeatureType,
class DataSet,
class LabelType,
class ExampleIndex,
class NodeType>
class DecisionForestEvaluator {
public:
/** Constructor. */
DecisionForestEvaluator();
/** Destructor. */
virtual ~DecisionForestEvaluator();
/** Evaluates the specified examples using the supplied forest.
*
* \param[in] DecisionForestEvaluator the decision forest
* \param[in] feature_handler the feature handler used to train the tree
* \param[in] stats_estimator the statistics estimation instance used while training
* the tree
* \param[in] data_set the data set used for evaluation
* \param[in] examples the examples that have to be evaluated
* \param[out] label_data the destination for the resulting label data
*/
void
evaluate(
pcl::DecisionForest<NodeType>& DecisionForestEvaluator,
pcl::FeatureHandler<FeatureType, DataSet, ExampleIndex>& feature_handler,
pcl::StatsEstimator<LabelType, NodeType, DataSet, ExampleIndex>& stats_estimator,
DataSet& data_set,
std::vector<ExampleIndex>& examples,
std::vector<LabelType>& label_data);
/** Evaluates a specific patch using the supplied forest.
*
* \param[in] DecisionForestEvaluator the decision forest
* \param[in] feature_handler the feature handler used to train the tree
* \param[in] stats_estimator the statistics estimation instance used while training
* the tree
* \param[in] data_set the data set used for evaluation
* \param[in] example the examples that have to be evaluated
* \param[out] leaves the leaves where the patch arrives
*/
void
evaluate(
pcl::DecisionForest<NodeType>& DecisionForestEvaluator,
pcl::FeatureHandler<FeatureType, DataSet, ExampleIndex>& feature_handler,
pcl::StatsEstimator<LabelType, NodeType, DataSet, ExampleIndex>& stats_estimator,
DataSet& data_set,
ExampleIndex example,
std::vector<NodeType>& leaves);
private:
/** Evaluator for decision trees. */
DecisionTreeEvaluator<FeatureType, DataSet, LabelType, ExampleIndex, NodeType>
tree_evaluator_;
};
} // namespace pcl
#include <pcl/ml/impl/dt/decision_forest_evaluator.hpp>
pcl
This file defines compatibility wrappers for low level I/O functions.
Definition: convolution.h:45
common.h
pcl::DecisionForestEvaluator::DecisionForestEvaluator
DecisionForestEvaluator()
Constructor.
Definition: decision_forest_evaluator.hpp:55
pcl::FeatureHandler
Utility class interface which is used for creating and evaluating features.
Definition: feature_handler.h:49
pcl::DecisionForestEvaluator::~DecisionForestEvaluator
virtual ~DecisionForestEvaluator()
Destructor.
Definition: decision_forest_evaluator.hpp:65
pcl::DecisionForest
Class representing a decision forest.
Definition: decision_forest.h:51
pcl::DecisionTreeEvaluator
Utility class for evaluating a decision tree.
Definition: decision_tree_evaluator.h:56
pcl::DecisionForestEvaluator
Utility class for evaluating a decision forests.
Definition: decision_forest_evaluator.h:57
pcl::DecisionForestEvaluator::evaluate
void evaluate(pcl::DecisionForest< NodeType > &DecisionForestEvaluator, pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > &feature_handler, pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > &stats_estimator, DataSet &data_set, std::vector< ExampleIndex > &examples, std::vector< LabelType > &label_data)
Evaluates the specified examples using the supplied forest.
Definition: decision_forest_evaluator.hpp:75
pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex >